package com.example.bluetooth.le;

import com.example.bluetooth.prt.HPRTHelper;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;

public class FunctionsActivity extends Activity implements OnClickListener{

	private EditText ed_fun_shocktime;
	private EditText ed_fun_sound_times;
	private HPRTHelper hprtHelper;
	private Context mContext;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_functions);
		initView();
		mContext = getApplicationContext();
		hprtHelper = HPRTHelper.getHPRTHelper(mContext);
	}

	private void initView() {
		// TODO Auto-generated method stub
		findViewById(R.id.btn_fun_lightbright).setOnClickListener(this);
		findViewById(R.id.btn_fun_lightflash).setOnClickListener(this);
		findViewById(R.id.btn_fun_lightoff).setOnClickListener(this);
		findViewById(R.id.btn_fun_shock).setOnClickListener(this);
		findViewById(R.id.btn_fun_soundlong).setOnClickListener(this);
		findViewById(R.id.btn_fun_soundshort).setOnClickListener(this);
		findViewById(R.id.layout_fun_poweroff).setOnClickListener(this);
		findViewById(R.id.layout_fun_restorefactory).setOnClickListener(this);
		ed_fun_shocktime = (EditText) findViewById(R.id.ed_fun_shocktime);
		ed_fun_sound_times = (EditText) findViewById(R.id.ed_fun_sound_times);
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.btn_fun_lightbright:
			light(1);
			break;
		case R.id.btn_fun_lightflash:
			light(2);
			break;
		case R.id.btn_fun_lightoff:
			light(3);
			break;
		case R.id.btn_fun_shock:
			shock();
			break;
		case R.id.btn_fun_soundlong:
			edTextsound(1);
			break;
		case R.id.btn_fun_soundshort:
			edTextsound(2);
			break;
		case R.id.layout_fun_poweroff:
			powerOff();
			break;
		case R.id.layout_fun_restorefactory:
			restoreFactory();
			break;

		default:
			break;
		}
	}
	private void light(int stype){
		if (!hprtHelper.printLight(stype)) {
			Util.ToastMessage(mContext, "send failed");
		}
	}
	private void sound(int soundstype, int times){
		if (!hprtHelper.printSound(soundstype, times)) {
			Util.ToastMessage(mContext, "send failed");
		}
	}
	private void edTextsound(int soundstype){
		if (Util.chackEdtextNoEmpty(mContext, ed_fun_sound_times, "time can not be zero")) {
			int times = Util.chackEdtextArea(mContext, ed_fun_sound_times, 1, 10, "exceed time limit");
			if (times!=-1) {
				sound(soundstype, times);
			}
		}
	}
	private void shock(){
		if (Util.chackEdtextNoEmpty(mContext,ed_fun_shocktime, "shock time can not be null")) {
			int time = Util.chackEdtextArea(mContext, ed_fun_shocktime, 1, 30, "shock time exceed time limit");
			if (time!=-1) {
				if(!hprtHelper.printShock(time)){
					Util.ToastMessage(mContext, "send failed");
				}
			}
		}
	}
	private void powerOff(){
		if (!hprtHelper.setPowerOff()) {
			Util.ToastMessage(mContext, "send failed");
		}
	}
	private void restoreFactory(){
		if (!hprtHelper.setRestorefactory()) {
			Util.ToastMessage(mContext, "send failed");
		}
	}
}
