package com.example.bluetooth.le;

import android.app.Activity;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;

import com.example.bluetooth.prt.HPRTHelper;

public class SettingActivity extends Activity implements OnClickListener{

	private RadioGroup rg_enter;
	private RadioGroup rg_letter;
	private EditText edScan;
	private RadioGroup rg_sound;
	private RadioGroup rg_shock;
	private RadioButton rb_enter_no;
	private RadioButton rb_enter_yes;
	private RadioButton rb_enter_lf;
	private RadioButton rb_enter_cr;
	private RadioButton rb_letter_big;
	private RadioButton rb_letter_originally;
	private RadioButton rb_letter_small;
	private RadioButton rb_sound_no;
	private RadioButton rb_shock_yes;
	private RadioButton rb_shock_no;
	private RadioButton rb_sound_yes;
	private EditText ed_gapsound_time;
	private EditText ed_longsound_time;
	private EditText ed_offpower_time;
	private EditText ed_offscan_time;
	private EditText ed_shock_time;
	private EditText ed_shortsound_number;
	private EditText ed_shortsound_time;
	private EditText ed_sound_number;
	private EditText ed_btclose_time;
	private Button btn_modify;
	private HPRTHelper helper;
	private SettingViewhold settingViewhold;
	private Context mContext;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_setting);
		mContext = getApplicationContext();
		initView();
		initData();
	}

	private void initData() {
		helper = HPRTHelper.getHPRTHelper(mContext);
		getSettingViewhold();
	}

	private void initView() {
		rg_enter = (RadioGroup) findViewById(R.id.rg_enter);
		rg_letter = (RadioGroup) findViewById(R.id.rg_letter);
		edScan = (EditText) findViewById(R.id.ed_scan_number);
		rg_sound = (RadioGroup) findViewById(R.id.rg_sound);
		rg_shock = (RadioGroup) findViewById(R.id.rg_shock);
		rb_enter_no = (RadioButton) findViewById(R.id.rb_enter_no);
		rb_enter_yes = (RadioButton) findViewById(R.id.rb_enter_yes);
		rb_enter_lf = (RadioButton) findViewById(R.id.rb_enter_lf);
		rb_enter_cr = (RadioButton) findViewById(R.id.rb_enter_cr);
		rb_letter_big = (RadioButton) findViewById(R.id.rb_letter_big);
		rb_letter_originally = (RadioButton) findViewById(R.id.rb_letter_originally);
		rb_letter_small = (RadioButton) findViewById(R.id.rb_letter_small);
		rb_sound_no = (RadioButton) findViewById(R.id.rb_sound_no);
		rb_sound_yes = (RadioButton) findViewById(R.id.rb_sound_yes);
		rb_shock_no = (RadioButton) findViewById(R.id.rb_shock_no);
		rb_shock_yes = (RadioButton) findViewById(R.id.rb_shock_yes);
		ed_gapsound_time = (EditText) findViewById(R.id.ed_gapsound_time);
		ed_longsound_time = (EditText) findViewById(R.id.ed_longsound_time);
		ed_offpower_time = (EditText) findViewById(R.id.ed_offpower_time);
		ed_offscan_time = (EditText) findViewById(R.id.ed_offscan_time);
		ed_shock_time = (EditText) findViewById(R.id.ed_shock_time);
		ed_shortsound_number = (EditText) findViewById(R.id.ed_shortsound_number);
		ed_shortsound_time = (EditText) findViewById(R.id.ed_shortsound_time);
		ed_sound_number = (EditText) findViewById(R.id.ed_sound_number);
		ed_btclose_time = (EditText) findViewById(R.id.ed_btclose_time);
		btn_modify = (Button) findViewById(R.id.btn_modify);
		btn_modify.setOnClickListener(this);
	}
	private void getSettingViewhold(){
		helper.getSettingData(new HPRTHelper.onReadData() {

			@Override
			public void succeed(byte[] data) {
				Log.d("TAG",HPRTHelper.byteArrayToHexStr(data));
				settingViewhold = new SettingViewhold(data[8], data[7], data[13], data[14], data[9], data[2], data[3], data[4], data[5], data[6], data[11], data[12],data[15]);
				setEnter();
				setSound();
				setEdtext();
				setShock();
				setLetter();
			}

			@Override
			public void failure() {
				// TODO Auto-generated method stub
				Builder dialog = Util.Dialog(SettingActivity.this, "Init","Get data failed");
				dialog.setNegativeButton("OK", new DialogInterface.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {
						// TODO Auto-generated method stub
						finish();
					}
				});
				dialog.show();
			}
		});
		helper.getBTCloseTime(new HPRTHelper.BTCloseTime() {
			@Override
			public void succeed(int time) {
				setBTCloseTime(time);
			}

			@Override
			public void failure() {
				Builder dialog = Util.Dialog(SettingActivity.this, "Init","Get data failed");
				dialog.setNegativeButton("OK", new DialogInterface.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {
						// TODO Auto-generated method stub
						finish();
					}
				});
				dialog.show();
			}
		});
	}

	private void setShock() {
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getShock()) {
			case 0:
				rg_shock.check(rb_shock_no.getId());
				break;
			case 1:
				rg_letter.check(rb_shock_yes.getId());
				break;
			default:
				break;
		}
	}

	;
	private void setLetter(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getLetter()) {
		case 0:
			rg_letter.check(rb_letter_originally.getId());
			break;
		case 1:
			Log.d("TAG","123");
			rg_letter.check(rb_letter_small.getId());
			break;
		case 2:
			rg_letter.check(rb_letter_big.getId());
			break;

		default:
			break;
		}
	}
	private void setEnter(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getEnter()) {
		case 0:
			rg_enter.check(rb_enter_no.getId());
			break;
		case 1:
			rg_enter.check(rb_enter_yes.getId());
			break;
		case 0x0a:
			rg_enter.check(rb_enter_lf.getId());
			break;
		case 0x0d:
			rg_enter.check(rb_enter_cr.getId());
			break;

		default:
			break;
		}
	}
	private void setSound(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getSound()) {
		case 0:
			rg_sound.check(rb_sound_no.getId());
			break;
		case 1:
			rg_sound.check(rb_sound_yes.getId());
			break;
			
		default:
			break;
		}
	}
	private void setEdtext(){
		if (settingViewhold==null) {
			return;
		}
		ed_gapsound_time.setText(settingViewhold.getGapSoundTime()<0?""+(settingViewhold.getGapSoundTime()+256):""+settingViewhold.getGapSoundTime());
		ed_longsound_time.setText(settingViewhold.getLongSoundTime()<0?""+(settingViewhold.getLongSoundTime()+256):""+settingViewhold.getLongSoundTime());
		ed_offpower_time.setText(settingViewhold.getOffPowerTime()<0?""+(settingViewhold.getOffPowerTime()+256):""+settingViewhold.getOffPowerTime());
		ed_offscan_time.setText(settingViewhold.getOffScanTime()<0?""+(settingViewhold.getOffScanTime()+256):""+settingViewhold.getOffScanTime());
		ed_shock_time.setText(settingViewhold.getShockTime()<0?""+(settingViewhold.getShockTime()+256):""+settingViewhold.getShockTime());
		ed_shortsound_number.setText(settingViewhold.getShortSoundNumber()<0?""+(settingViewhold.getShortSoundNumber()+256):""+settingViewhold.getShortSoundNumber());
		ed_shortsound_time.setText(settingViewhold.getShortSoundTime()<0?""+(settingViewhold.getShortSoundTime()+256):""+settingViewhold.getShortSoundTime());
		ed_sound_number.setText(settingViewhold.getSoundNumber()<0?""+(settingViewhold.getSoundNumber()+256):""+settingViewhold.getSoundNumber());
		edScan.setText(settingViewhold.getScan()<0?""+(settingViewhold.getScan()+256):""+settingViewhold.getScan());
	}
	private void setBTCloseTime(int time){
		ed_btclose_time.setText(""+time);
	}
	

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.btn_modify:
			modify();
			break;

		default:
			break;
		}
	}
	private void modify(){
		if (settingViewhold==null) {
			return;
		}
		switch (rg_letter.getCheckedRadioButtonId()) {
		case R.id.rb_letter_originally:
			settingViewhold.setLetter(0);
			break;
		case R.id.rb_letter_small:
			settingViewhold.setLetter(1);
			break;
		case R.id.rb_letter_big:
			settingViewhold.setLetter(2);
			break;
		default:
			break;
		}
		switch (rg_enter.getCheckedRadioButtonId()) {
		case R.id.rb_enter_no:
			settingViewhold.setEnter(0);
			break;
		case R.id.rb_enter_yes:
			settingViewhold.setEnter(1);
			break;
		case R.id.rb_enter_lf:
			settingViewhold.setEnter(10);
			break;
		case R.id.rb_enter_cr:
			settingViewhold.setEnter(13);
			break;
		default:
			break;
		}
		switch (rg_sound.getCheckedRadioButtonId()) {
		case R.id.rb_sound_no:
			settingViewhold.setSound(0);
			break;
		case R.id.rb_sound_yes:
			settingViewhold.setSound(1);
			break;
		default:
			break;
		}
		switch (rg_shock.getCheckedRadioButtonId()) {
		case R.id.rb_shock_no:
			settingViewhold.setShock(0);
			break;
		case R.id.rb_shock_yes:
			settingViewhold.setShock(1);
			break;
		default:
			break;
		}
		if(!Util.chackEdtextNoEmpty(mContext, ed_gapsound_time, "Interval is null")){
			return;
		}
		int scanNumber = Util.chackEdtextArea(mContext, edScan, 0, 10, "Scan exceed limit");
		if (scanNumber==-1) {
			return;
		}
		settingViewhold.setScan(scanNumber);
		int gapSoundTime = Util.chackEdtextArea(mContext, ed_gapsound_time, 1, 5, "Interval exceed limit");
		if (gapSoundTime==-1) {
			return;
		}
		settingViewhold.setGapSoundTime(gapSoundTime);

		if(!Util.chackEdtextNoEmpty(mContext, ed_longsound_time, "LDi time null")){
			return;
		}
		int longSoundTime = Util.chackEdtextArea(mContext, ed_longsound_time, 3, 30, "LDi time exceed limit");
		if (longSoundTime==-1) {
			return;
		}
		settingViewhold.setLongSoundTime(longSoundTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_offpower_time, "Power off time 0")){
			return;
		}
		int offPowerTime = Util.chackEdtextArea(mContext, ed_offpower_time, 3, 60, "Power off time exceed limit");
		if (offPowerTime==-1) {
			return;
		}
		settingViewhold.setOffPowerTime(offPowerTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_offscan_time, "Power off scan time 0")){
			return;
		}
		int offScanTime = Util.chackEdtextArea(mContext, ed_offscan_time, 3, 60, "Power off scan time exceed limit");
		if (offScanTime==-1) {
			return;
		}
		settingViewhold.setOffScanTime(offScanTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_shock_time, "Shock time 0")){
			return;
		}
		int shockTime = Util.chackEdtextArea(mContext, ed_shock_time, 3, 30, "Shock time exceed limit");
		if (shockTime==-1) {
			return;
		}
		settingViewhold.setShockTime(shockTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_shortsound_number, "SDi count 0")){
			return;
		}
		int shortSoundNumber = Util.chackEdtextArea(mContext, ed_shortsound_number, 1, 10, "SDi count exceed limit");
		if (shortSoundNumber==-1) {
			return;
		}
		settingViewhold.setShortSoundNumber(shortSoundNumber);
		if(!Util.chackEdtextNoEmpty(mContext, ed_shortsound_time, "SDi count 0")){
			return;
		}
		int shortSoundTime = Util.chackEdtextArea(mContext, ed_shortsound_time, 1, 5, "SDi count exceed limit");
		if (shortSoundTime==-1) {
			return;
		}
		settingViewhold.setShortSoundTime(shortSoundTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_sound_number, "sound value 0")){
			return;
		}
		int soundNumber = Util.chackEdtextArea(mContext, ed_sound_number, 1, 255, "sound value exceed limit");
		if (soundNumber==-1) {
			return;
		}
		settingViewhold.setSoundNumber(soundNumber);
		int btCloseTime = Util.chackEdtextArea(mContext, ed_btclose_time, 0, 10, "broadcast value exceed limit");
		if (btCloseTime==-1) {
			return;
		}
		boolean b = helper.setBTCloseTime(btCloseTime);
		int sum=17+settingViewhold.getEnter()+settingViewhold.getGapSoundTime()+settingViewhold.getLetter()+settingViewhold.getLongSoundTime()+settingViewhold.getOffPowerTime()
				+settingViewhold.getOffScanTime()+settingViewhold.getScan()+settingViewhold.getShockTime()+settingViewhold.getShortSoundNumber()+settingViewhold.getShortSoundTime()
				+settingViewhold.getSound()+settingViewhold.getSoundNumber()+settingViewhold.getShock();
		boolean setSetting = helper.setSetting(new byte[]{0x02,14,(byte)settingViewhold.getLongSoundTime(),(byte)settingViewhold.getShortSoundTime(),(byte)settingViewhold.getGapSoundTime()
				,(byte)settingViewhold.getShortSoundNumber(),(byte)settingViewhold.getShockTime(),(byte)settingViewhold.getEnter(),(byte)settingViewhold.getLetter()
				,(byte)settingViewhold.getSoundNumber(),1,(byte)settingViewhold.getOffScanTime(),(byte)settingViewhold.getOffPowerTime(),(byte)settingViewhold.getScan()
				,(byte)settingViewhold.getSound(),(byte)settingViewhold.getShock(),(byte)sum
		});
		if (setSetting&b) {
			Util.ToastMessage(mContext, "Modify succeed");
		}else {
			Util.ToastMessage(mContext, "Modify failed");
		}
	}
}
