package com.example.bluetooth.le;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.TextView;

import com.example.bluetooth.prt.HPRTHelper;
import com.example.bluetooth.prt.HPRTHelper.onTemporarilySaveCount;
import com.example.bluetooth.prt.HPRTHelper.onUpLodeTemporarilyData;

public class TemporarilyActivity extends Activity implements OnClickListener{

	private Context mContext;
	private TextView tv_temporarily_data;
	private RadioGroup rg_tem_switch;
	private RadioButton rb_tem_open;
	private RadioButton rb_tem_close;
	private TextView tv_save_count;
	private HPRTHelper hprtHelper;
	private boolean mIsSaveOpen=true;
	private int mSavedCount=0;
	String str="";
	int num=1;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_temporarily);
		mContext = getApplicationContext();
		initView();
		initData();
	}

	private void initData() {
		hprtHelper = HPRTHelper.getHPRTHelper(mContext);
		TemSaveCount();
		rg_tem_switch.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(RadioGroup arg0, int arg1) {
				// TODO Auto-generated method stub
//				System.out.println("rg_tem_switch："+arg1);
				if(arg1==rb_tem_open.getId()){
					if(!mIsSaveOpen){
						mIsSaveOpen=true;
						hprtHelper.setTemporarilySave(1);//开启
					}
				}else{
					if(mIsSaveOpen){
						mIsSaveOpen=false;
						hprtHelper.setTemporarilySave(0);//关闭
					}
				}
			}
		});
	}

	private void TemSaveCount() {
		hprtHelper.getTemporarilySaveCount(new onTemporarilySaveCount() {
			
			@Override
			public void succeed(boolean isSvaeOpen, int savedCount, int leftCount) {
				// TODO Auto-generated method stub
				mIsSaveOpen=isSvaeOpen;
				mSavedCount=savedCount;
				if(isSvaeOpen){
					rg_tem_switch.check(rb_tem_open.getId());
				}else{
					rg_tem_switch.check(rb_tem_close.getId());
				}
				tv_save_count.setText("save count"+ savedCount+ "   count to get："+leftCount);
//				if (savedCount==0) {
//					ed_tem_start.setText("0");
//					ed_tem_end.setText("0");
//				}else{
//					ed_tem_start.setText("1");
//					ed_tem_end.setText(""+savedCount);
//				}
			}
			
			@Override
			public void failure() {
				// TODO Auto-generated method stub
				Builder dialog = Util.Dialog(TemporarilyActivity.this, "error", "get data failed");
				dialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
					
					@Override
					public void onClick(DialogInterface arg0, int arg1) {
						// TODO Auto-generated method stub
						finish();
					}
				});
				dialog.show();
			}
		});
	}

	private void initView() {
		tv_temporarily_data = (TextView) findViewById(R.id.tv_temporarily_data);
		tv_temporarily_data.setMovementMethod(ScrollingMovementMethod.getInstance()) ; 
		rg_tem_switch = (RadioGroup) findViewById(R.id.rg_tem_switch);
		rb_tem_open = (RadioButton) findViewById(R.id.rb_tem_open);
		rb_tem_close = (RadioButton) findViewById(R.id.rb_tem_close);
		tv_save_count = (TextView) findViewById(R.id.tv_save_count);
		findViewById(R.id.btn_tem_uplode).setOnClickListener(this);
		findViewById(R.id.btn_tem_updata).setOnClickListener(this);
		findViewById(R.id.tv_tem_cleandata).setOnClickListener(this);
	}

	@Override
	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		switch (arg0.getId()) {
		case R.id.btn_tem_uplode:
			upLode();
			break;
		case R.id.btn_tem_updata:
			upData();
			break;
		case R.id.tv_tem_cleandata:
			Builder dialog = Util.Dialog(TemporarilyActivity.this, "Warnning", "Clear buffer data");
			dialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
				
				@Override
				public void onClick(DialogInterface arg0, int arg1) {
					// TODO Auto-generated method stub
					hprtHelper.cleanTemporarilySaveData();
					TemSaveCount();
				}
			});
			dialog.setNegativeButton("Cancel", null);
			dialog.show();
			break;

		default:
			break;
		}
	}

	private void upData() {
		// TODO Auto-generated method stub
		TemSaveCount();
		tv_temporarily_data.setText("");
	}

	private void upLode() {
		// TODO Auto-generated method stub
//		if(!Util.chackEdtextNoEmpty(mContext, ed_tem_start, "起始条数不能为空")){
//			return;
//		}
//		if(!Util.chackEdtextNoEmpty(mContext, ed_tem_end, "结尾条数不能为空")){
//			return;
//		}
//		if(Util.chackEdtextArea(mContext, ed_tem_start, 1, mSavedCount, "起始条数设置错误")==-1){
//			return;
//		}
//		int startNumber = Integer.valueOf(ed_tem_start.getText().toString());
//		int endNumber = Integer.valueOf(ed_tem_end.getText().toString());
//		if(Util.chackEdtextArea(mContext, ed_tem_end, startNumber, mSavedCount, "结尾条数设置错误")==-1){
//			return;
//		}
		str="";
		num=1;
//		final Builder dialog = Util.Dialog(TemporarilyActivity.this, "消息", "正在上传数据。。");
		final AlertDialog dialog = new AlertDialog.Builder(TemporarilyActivity.this).create();
		dialog.setTitle("Message");
		dialog.setMessage("Uploading data...");
		dialog.show();
		new Thread(){
			public void run() {
				hprtHelper.upLodeTemporarilyData(new onUpLodeTemporarilyData() {
					
					@Override
					public void succeed(byte[] data,int tap) {
						// TODO Auto-generated method stub
						if (tap==1){
							String s = Util.byteASCIIstr(data);
							if (!s.endsWith("\\n")){
								s=s+"\n";
							}
							str=str+num+" "+ s;
							num++;
						}
						if(tap==0){
							tv_temporarily_data.post(new Runnable() {
								@Override
								public void run() {
									// TODO Auto-generated method stub
									dialog.dismiss();
									tv_temporarily_data.setText(str);
								}
							});
						}
					}
					
					@Override
					public void failure() {
						// TODO Auto-generated method stub
						
					}
				});
			};
		}.start();
		
	}
}
