package com.example.bluetooth.le;

import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

public class Util {
	private static boolean isLog=true;
	public static boolean chackEdtextNoEmpty(Context context,EditText editText,String str){
		String edstr = editText.getText().toString().trim();
		if (edstr.length()==0) {
			ToastMessage(context, str);
			return false;
		}else {
			return true;
		}
	}
	public static int chackEdtextArea(Context context,EditText editText,int lessNumber,int moreNumber,String str){
		String edstr = editText.getText().toString().trim();
		if (TextUtils.isEmpty(edstr)){
			ToastMessage(context, str);
			return -1;
		}
		if (edstr.length()>4){
			ToastMessage(context, str);
			return -1;
		}
		int valueOf = Integer.valueOf(edstr);
		if (valueOf<lessNumber||valueOf>moreNumber) {
			ToastMessage(context, str);
			return -1;
		}else {
			return valueOf;
		}
	}
	public static AlertDialog.Builder Dialog(Context context,String title,String message){
		Builder builder = new AlertDialog.Builder(context);
		builder.setTitle(title).setMessage(message);
		return builder;
	}
	public static void ToastMessage(Context context,String message){
		Toast.makeText(context, message, Toast.LENGTH_SHORT).show();
	}
	public static AlertDialog.Builder DialogView(Context context,View view){
		Builder builder = new AlertDialog.Builder(context);
		return builder.setView(view);
	}
	public static String byteASCIIstr(byte[] by){
		String str="";
		for (int i = 0; i < by.length; i++) {
			char b=(char)by[i];
			str+=b;
		}
		return str;
	}
	public static String stringToOctal(String str){
		int m=str.length()/2;
		if(m*2<str.length()){
			m++;
		}
		String[] strs=new String[m];
		int j=0;
		for(int i=0;i<str.length();i++){
			if(i%2==0){//每隔两个
				strs[j]=""+str.charAt(i);
			}else{
				strs[j]=strs[j]+str.charAt(i);
				j++;
			}
		}
		String result="{C";
		for (int i = 0; i < strs.length; i++) {
			if (strs[i].length()==2) {
				if(!isNumeric(strs[i])){
					return "";
				}
				String s = Integer.toOctalString(Integer.valueOf(strs[i]));
				if (s.length()==2){
					result=result+"\\0";
				}else{
					result=result+"\\";
				}
				result+=s;
			}else{
				result+="{A"+str.substring(str.length()-1,str.length());
			}
		}
		return result;
	}
	public static boolean isNumeric(String str){
		for (int i = str.length();--i>=0;){
			if(!Character.isDigit(str.charAt(i))){
				return false;
			}
		}
		return true;
	}
	public static void d(String tag,String message){
		if(isLog) Log.d(tag,message);
	}
}
